<template>
  <div class="mapBox">
    <ol-map
      id="map"
      :loadTilesWhileAnimating="true"
      :loadTilesWhileInteracting="true"
      :cluster="true"
      @singleclick="handleMapClick"
    >
      <ol-view ref="view" :center="centerMap()" :zoom="zoom" />

      <ol-tile-layer>
        <ol-source-osm />
      </ol-tile-layer>

      <ol-vector-layer>
        <ol-source-vector ref="vectorsource" @addfeature="handleFeatureAdd">
          <ol-feature v-for="(location, key) in locations" :key="location.name">
            <ol-geom-point
              :coordinates="toXY(location.lon, location.lat)"
            ></ol-geom-point>
            <ol-style>
              <ol-style-icon
                :src="key == activeLocation ? selectedMarkerIcon : markerIcon"
                :scale="0.5"
                positioning="top-center"
                :style="`filter: brightness(1.2) sepia(100%) hue-rotate(90deg)`"
              ></ol-style-icon>
            </ol-style>
          </ol-feature>
        </ol-source-vector>
      </ol-vector-layer>
    </ol-map>
  </div>
</template>

<script>
import { ref } from "vue";
import { fromLonLat } from "ol/proj";
import markerIcon from "@/assets/pin.png";
import selectedMarkerIcon from "@/assets/pinSelected.png";

export default {
  props: {
    locations: {
      type: Array,
    },
    activeLocation: {
      type: Number,
    },
  },
  components: {},
  setup() {
    const zoom = ref(13.5);
    // const rotation = ref(0);
    const coordinate = ref([40, 40]);

    return {
      zoom,
      markerIcon,
      coordinate,
      selectedMarkerIcon,
    };
  },
  data() {
    return {
      center: fromLonLat([3.7099, 51.0602]),
    };
  },
  methods: {
    toXY(lon, lat) {
      return fromLonLat([lon, lat]);
    },
    centerMap() {
      return this.center;
    },
    computed: {
      computedCenter() {
        return this.center;
      },
    },
    updateCenter(index) {
      console.log("Center change");
      if (this.locations[index]?.lon + this.locations[index]?.lat != 0) {
        var temp = fromLonLat([
          this.locations[index].lon,
          this.locations[index].lat,
        ]);
        console.log(temp);
        this.center = temp;
      }
    },
    handleFeatureAdd(event) {
      const feature = event.detail.feature;
      const location = this.locations.find(
        (loc) => loc.name === feature.get("name")
      );
      feature.set("location", location);
      feature.on("click", this.handleFeatureClick);
    },
    handleFeatureClick(event) {
      const feature = event.target;
      const location = feature.get("location");
      console.log("Clicked location:", location);
      console.log("feature" + feature);
      // Perform any additional actions based on the clicked location
      this.$emit("setActiveLocation", 1);
    },
    handleMapClick(event) {
      const map = event.target;
      const clickedFeatures = map.getFeaturesAtPixel(event.pixel);
      if (clickedFeatures.length > 0) {
        const clickedFeature = clickedFeatures[0];
        const clickedCoordinates = clickedFeature
          .getGeometry()
          .getCoordinates();
        const location = this.locations.find((loc) =>
          this.coordinatesEqual(clickedCoordinates, this.toXY(loc.lon, loc.lat))
        );
        console.log("Clicked location:", location);
        this.$emit("setActiveLocation", this.locations.indexOf(location));
      }
    },
    coordinatesEqual(coord1, coord2) {
      return coord1[0] === coord2[0] && coord1[1] === coord2[1];
    },
  },

  computed: {
    getIconFilter() {
      return function (isActive) {
        // Generate the CSS filter based on the color
        // Example: Change brightness and hue of the icon
        if (isActive) {
          return `brightness(2) sepia(100%) hue-rotate(180deg)`;
        } else return "";
      };
    },
  },
};
</script>

<style lang="scss" scoped>
.mapBox {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  width: 100%;
  height: 25rem;
  #map {
    flex-grow: 5;
    min-height: 10rem;
    height: 100%;
    width: 100%;
  }
}
</style>
